(function(){
    v8Console.log("Android V8 Js Bridge Load");
    global = globalThis;
    var messageHandlers = {};
    var responseCallbacks = {};
    var uniqueId = 1;

    _dm = {
        _registerMethod:_registerMethod,
        _sendMessage:_sendMessage,
        _sendMessageSync:_sendMessageSync,
        onJsCallback:onJsCallback,
        onJavaRequest:onJavaRequest,
        genJsId:genJsId,
        getDeviceInfoSync:getDeviceInfoSync
    };

    function getDeviceInfoSync() {
        return _sendMessageSync({method:"getDeviceInfoSync",data:{}});
    }

    function _registerMethod(methodName, handler){
        messageHandlers[methodName] = handler;
    }

    function _sendMessage(message, callback){
        obj = methodObj(message.method);
        reassembleMessage = Object.assign(message,obj);
        callbackId = genJsId();
        if(callback){
            responseCallbacks[callbackId] = callback;
        }
        wrappedMessage = {};
        wrappedMessage[callbackId] = reassembleMessage;
        value = JSON.stringify(wrappedMessage);
        prompt(value);
    }

    function _sendMessageSync(message){
        messageObj = methodObj(message.method);
        reassembleMessage = Object.assign(message,methodObj);

        value = JSON.stringify(reassembleMessage);
        response = prompt(value);
        v8Console.log("sendMessageSync response: " + response);
        if(response.indexOf("DM_BRIDGE_ERROR") !== -1){
            v8Console.log(response);
            return null;
        }
        if(response.startsWith("DMALL_TYPE[STRING]")){
            response = response.replace("DMALL_TYPE[STRING]","");
        }else{
            try{
                response = JSON.parse(response);
            }catch(e){

            }
        }
        return response;
    }

    function methodObj(method){
        dotPos = method.lastIndexOf('.');
        className = method.substring(0, dotPos);
        methodName = method.substring(dotPos === 0 ? 0 : dotPos + 1, method.length);
        obj = {};
        if(className){
            obj.className = className;
        }
        if(methodName){
            obj.method = methodName;
        }
        return obj;
    }

    function onJsCallback(messageText) {
        if(messageText&&messageText.indexOf("base64")>0){
            v8Console.log("base64: may be too big, ignore print...");
        } else {
            v8Console.log("onJsCallback: " + messageText);
        }
        var message = JSON.parse(messageText);
        for (var key in message) {
            var callbackHandler = responseCallbacks[key];
            v8Console.log('callbackHandler: ' + callbackHandler);
            if (callbackHandler !== undefined) {
                var response = message[key];
                var typeOfResponse = typeof response;
                var tryTime = 0;
                while (typeOfResponse === 'string' && tryTime < 3) {
                    response = JSON.parse(response);
                    typeOfResponse = typeof response;
                    if (tryTime >= 2 && typeOfResponse === 'string') {
                        response = {data: response};
                    }
                    tryTime++
                }
                callbackHandler(response);
            } else {
                if (message[key].indexOf("{\\\"TAG\\\":\\\"DM_BRIDGE_ERROR\\\",") > -1) {
                    v8Console.log(message[key]);
                }
            }
            delete responseCallbacks[key];
            return;
        }
    }

    function onJavaRequest(messageText) {
        v8Console.log("onJavaRequest: " + messageText);
        var message = JSON.parse(messageText);
        var methodName = message.method;
        var messageHandler = messageHandlers[methodName];
        if(messageHandler){
            messageHandler(message.data);
        }
    }

    function genJsId() {
        return 'jscb_async_' + (uniqueId++) + '_' + new Date().getTime();
    }
})();