/**
 galleon.Navigator
 galleon.Storage
 galleon.Sys = {
 getInfo : function() {},
 getStacks : function( res ) {
 ['asef','asdf','asdf']
 }
 }
 */


(function () {
    function parseJSON(str) {
        if (typeof str != 'string') {
            return str;
        }
        try {
            return (new Function('return ' + str + ';'))();
        } catch (e) {
            return {};
        }
    }

    if (typeof window == 'undefined') {
        window = {};
    }

    var handle, _fn,
        sysInfo = galleon.Sys.getInfo();


    sysInfo = parseJSON(sysInfo + ''); // 转字符 hack android bug

    handle = {
        /**
         @url String 处理前url
         @context Object 执行上下文

         返回 pixie:stop 禁止往下执行
         */
        // forward拦截代码
        parseUri: function (uri, context) {
            // uri = _fn.redirectList(uri); // 跳转重定向
            return uri;
            //return ; //返回 pixie:stop 禁止往下执行
        },

        /**
         @url String 处理前url
         @context Object 执行上下文

         返回 pixie:stop 禁止往下执行
         */
        // 扫码页拦截代码
        parseScanUri: function (uri, context) {
            // uri = _fn.whiteList(uri); // 处理扫码跳转的白名单
            // uri = _fn.parseRNUri(uri); // 解析rn相关的规则
            return uri;
        }
    }


    _fn = {
        redirectList: function (uri) { //跳转重定向
            uri = uri + '';
            if (_fn.isHN(uri)) {  //是否为 HN 地址
                var targetUri = _fn.convertToHN(uri);
                _fn.jump('forward', targetUri, '');
                return 'pixie:stop';
            }
            return uri;
        },
        whiteList: function (uri) {
            uri = uri + '';
            if (uri.indexOf('.lsh123.com') > 0) { //放行链家的域
                _fn.jump('forward', uri, '');
                return 'pixie:stop';
            }
            return uri;
        },
        // 包括 判断是否为hn
        isHN: function (uri) {
            // 目前 采用灵活方案 来处理
            // 后续根据反馈来处理是否要做 严格校验
            var urlParam = _fn.getUrlParam(uri);
            if (
                // uri.indexOf('stallpos.wumart.com/stall/redirec') > 0 &&
                uri.match(/^(http:\/\/|https:\/\/|\/\/)\w*.dmall-os.cn/) &&
                urlParam.hn
            ) {
                return true
            }
            return false
        },
        // 转换为 hn 地址
        convertToHN: function(uri){
            // hn://cxm_choosestore/page/mapNear/mapNear.html#full/cxm_choosestore/mapNear:abc=3333
            var result = '';
            var hash = uri.split('#')[1] || '';
            var path = (hash.split(':')[0] || '').split('/') || [];
            var search = _fn.getUrlParam(uri);
            var searchStr = _fn.parseParam(search, '?') || '';
            //目前锁死了这个逻辑(#布局/项目/页面)
            if(path.length === 3){
                var projectName = path[1];
                var pageName = path[2];
                result = 'hn://' + projectName + '/pages/' + pageName + '/' + pageName + '.html' + searchStr + '#' + hash;
            }
            return result;
        },
        getUrlParam: function (parmUrl, name) {
            parmUrl = parmUrl || location.href;
            name = name || '';
            var loc = parmUrl.split('?'),
                search = loc[1] || '',
                url = '',
                result, i, s;

            search = search.split('#')[0] || '';
            search = search.split('&');
            if (name) {
                var reg = new RegExp('(^|&)' + name + '=([^&]*)(&|$)', 'i'),
                    r = (loc[1] || '').match(reg),
                    type = r ? decodeURIComponent(r[2]) : '';
                result = type.split('#')[0] || '';
            } else {
                result = {};
                for (i = 0; s = search[i]; ++i) {
                    s = s.split('=');
                    if (s.length == 2) {
                        result[s[0]] = s[1];
                    }

                }
            }
            return result;
        },
        paramToObj: function (str) {
            str = str || '';
            var result = {},
                list = str.split('&'),
                p, i, len;

            for (i = 0, len = list.length; i < len; ++i) {
                p = (list[i] + '').split('=');
                if (p.length != 2) {
                    continue;
                }
                result[p[0]] = p[1];
            }
            return result;
        },
        parseParam: function (param, concatChar) {
            param = param || [];
            concatChar = concatChar || '?';
            var paramStr = [], key;
            for (key in param) {
                // paramStr.push(key + '=' + encodeURIComponent(param[key]));
                // paramStr.push( key + '=' + encodeURIComponent(param[key]) );
                paramStr.push( key + '=' + param[key] );
            }

            paramStr = paramStr.join('&');
            return paramStr == '' ? '' : concatChar + paramStr;
        },
        getENV: function (uri) { //获取环境
            var env = 'https://';
            if (uri.indexOf('//test') > 0 || uri.indexOf('env=test') > 0) {
                env = 'https://test';
            } else if (uri.indexOf('//dev') > 0 || uri.indexOf('env=dev') > 0) {
                env = 'https://dev'
            }
            return env;
        },
        /**
         *
         * @param {*} method (forward, replace)
         * @param {*} uri
         * @param {*} context
         */
        jump:function(method, uri, context){
            try {
                galleon.Navigator[method](uri, context);
            } catch (error) {
            }
        },

    }

    //var result = handle.parseScanUri('https://a.dmall.com/act/wFkq0RQDl1ti.html?erpStoreId=230&dmfrom=wx&from=wx&shareKey=1524467832738');
    //console.log( result );
    window.pixie = handle;
})();
