<div class="cabin-page-watermark content-container cabin-componets-conts cabin-doc-markdown" id="cabin-page-watermark"><div class="container-scroll"><div class="container-scroll-content"><h2>Watermark 水印</h2><p>该插件不依赖任何三方技术，原生js实现，支持cabin和非Cabin体系项目使用。</p><h2>1、cabin体系项目</h2><h3><strong>用法介绍</strong></h3><h3 class="stage-title">项目级使用（有入口页的项目）</h3><p>自动添加水印（不支持更新和销毁水印）：在入口页面（一般是html>index.html中）配置cabin.config.watermark，详细参数查看如下代码：</p><p>不需要自动添加水印的页面在pageLists列表中添加相应页面的define命名。</p><p class="font-error">推荐做法，请在登录成功后把登录信息存放在cookie中或storage中，在login.js中成功后逻辑处 和 在main.js中的版本号设置之后 设置cabin.config.watermark，设置需要的信息可在cookie或storage中获取，具体使用请看如下事例：</p><pre><code>
cabin.config = $.extend(cabin.config || {}, {
  watermark: {
    autoAdd: true,//是否添加水印
    content: '我是水印', //水印文案
    hideContent:'',//隐藏式水印的文案，没有则取content的配置
    projectName: 'cabin', //项目名称
    pageLists: [ //页面define的路径，列表为不需要自动添加水印的页面
      'cabin/pages/components/up/btn/btn',
      'cabincenter/pages/intro/intro'
    ]
  }
}); 
</code></pre><h3 class="stage-title">页面级使用</h3><p>自动添加水印（不支持更新和销毁水印）</p><p>jq和vue用法分别在page()和vuePage()中配置参数config.watermark，详细参数查看如下代码：</p><p class="font-error">配置需要的信息可同上在cookie或storage中获取。</p><ul><li><p>jq：</p><pre><code>
var watermark = require('cabin/widgets/watermark/watermark');

page = Page({
  nodeClass: 'pages-cabin-xxx',
  parentClass: 'J_Main', // 没有就直接插入body，或者不插入
  source: ['cabin/pages/components/xxx/xxx.tpl', 'cabin/pages/components/xxx/xxx.css'],
  config：{
    watermark:{ 
       autoAdd: true,//是否添加水印
       content: '我是水印',//水印文案
       hideContent:'',//隐藏式水印的文案，没有则取content的配置
    }
  },
  show: function () {
    handle.jView = this.jView;
  },
  hide: function () {},
  on: {}
});
          </code></pre></li><li><p>vue：</p><pre><code>
var watermark = require('cabin/widgets/watermark/watermark');

page = VuePage({
  source: ['cabin/pages/xxx/xxx.tpl', 'cabin/pages/xxx/xxx.css'],
  el: 'cabin-page-xxx',
  config：{
    watermark:{ 
       autoAdd: true,//是否添加水印
       content: '我是水印',//水印文案
       hideContent:'',//隐藏式水印的文案，没有则取content的配置
    }
  },
  data: function () {
    return {}
  },
  mounted: function () {
    this.$nextTick(function () {
     
    });
  },
  beforeDestory: function () {},
  methods: {}
});
          </code></pre></li></ul><h2>2、非cabin体系项目</h2><p class="font-error">非Cabin体系项目只支持手动添加水印，不支持自动。</p><h3><strong>资源引入</strong></h3><ul><li>在入口html页面引入：<pre><code>&lt;script src="http://static.dmall.com/kayak-project/cabin/dist/cabin/widgets/watermark/watermark.js">&lt;/script></code></pre></li></ul><h3><strong>用法介绍</strong></h3><pre><code>//引入插件
&lt;script src="http://static.dmall.com/kayak-project/cabin/dist/cabin/widgets/watermark/watermark.js">&lt;/script>

//方法一：
var waterEx=new Watermark({
    autoAdd: true,//是否添加水印
    containerCls: 'J_watermark_demo', //容器class名称
    content: '我是水印', //水印文案
    hideContent:'',//隐藏式水印的文案，没有则取content的配置
});

//方法二：
var waterEx=new Watermark(); 
waterEx.render({
    autoAdd: true,//是否添加水印
    containerCls: 'J_watermark_demo', //容器class名称
    content: '我是水印', //水印文案
    hideContent:'',//隐藏式水印的文案，没有则取content的配置
});
</code></pre><p>demo</p><code-temp v-bind:showdemo="true" v-bind:showhtml="true" v-bind:showjs="true" v-bind:showcss="false"><div slot="demo"><div class="J_watermark_demo" style="width:100%;height:250px"></div></div><div slot="html"><pre><code>&lt;div class="J_watermark_demo" style="width:100%;height:250px;">&lt;/div></code></pre></div><div slot="js"><pre><code>
&lt;script src="http://static.dmall.com/kayak-project/cabin/dist/cabin/widgets/watermark/watermark.js">&lt;/script>
          
var waterEx = new Watermark({
  autoAdd: true,//是否添加水印
  containerCls: 'J_watermark_demo', //容器class名称
  content: '测试测试', //水印文案
  hideContent:'',//隐藏式水印的文案，没有则取content的配置
});
          </code></pre></div></code-temp><div class="stage-title flag">Watermark 参数说明</div><div class="table-responsive"><table class="cabinTable table table-hover table-top-bordered table-bottom-bordered"><thead><tr><th>参数</th><th>说明</th><th>类型</th><th>可选值</th><th>默认值</th></tr></thead><tbody><tr><td><div>containerCls</div></td><td><div>容器class名称，该class多个dom使用时，水印会在每个dom内添加。如需指定唯一容器添加，请保证class名称唯一。</div></td><td><div>string</div></td><td><div>-</div></td><td><div>当未定义containerCls时，默认会在body内添加水印。</div></td></tr><tr><td><div>content</div></td><td><div>水印文案</div></td><td><div>string</div></td><td><div>-</div></td><td><div>多点生活</div></td></tr><tr><td><div>hideContent</div></td><td><div>隐藏式水印文案</div></td><td><div>string</div></td><td><div>-</div></td><td><div>没有则取content的配置</div></td></tr></tbody></table></div><div class="stage-title flag">Watermark 方法说明</div><div class="table-responsive"><table class="cabinTable table table-hover table-top-bordered table-bottom-bordered"><thead><tr><th>方法名</th><th>说明</th><th>使用方法</th></tr></thead><tbody><tr><td><div>render</div></td><td><div>初始化实例</div></td><td><div>例如：声明的水印实例.render(options);</div></td></tr><tr><td><div>update</div></td><td><div>更新实例，在参数发生变化时使用</div></td><td><div>例如：声明的水印实例.update(options);注：更新时无需传递containerCls，会沿用render()时的containerCls参数。</div></td></tr><tr><td><div>destroy</div></td><td><div>销毁实例</div></td><td><div>例如：声明的水印实例.destroy();</div></td></tr></tbody></table></div></div></div></div>