<div class="cabin-page-autoPack content-container"><div class="container-scroll"><div class="stage"><div class="stage-title">项目支持服务器自动打包和修改版本号后，只需将代码提交到git上即可，无需下载打包依赖的文件（无需执行npm i），也无需执行npm run build进行打包和手动修改版本号</div></div><div class="stage"><div class="stage-title">配置方式如下(<span class="font-error">项目第一次配置自动打包请联系测试和运维同事在服务器端同步配置下，服务器只需配置一次</span>)：</div></div><div class="stage"><div class="stage-title flag">方式一（使用脚手架创建项目）：</div><div style="padding:0 20px 20px"><p>使用脚手架创建项目，提示<span class="font-error" style="margin:0 10px">“需要服务器自动打包、修改版本号?(物美环境暂不支持自动打包功能！！)”</span>选项时选择Y即可!</p><p class="font-error">PS:该选项支持情况如下：</p><p>多点环境：<span class="font-error">支持服务器自动打包，自动修改版本号！</span></p><p>物美环境：<span class="font-error">支持在本地打包时自动修改版本号！！</span></p></div></div><div class="stage"><div class="stage-title flag">方式一（针对已存在项目）：</div><div style="padding:0 20px 20px"><p>1、修改项目根目录下的Gruntfile.js，全局替换为以下代码：</p><p>2、修改项目src目录下的main.js(修改后无需手动修改版本号)：</p><p><span class="font-error">/*版本号*/ 'kayak-version 201712071148'</span> 替换为 <span class="font-error">/*版本号*/ 'kayak-version #versionTime#'。</span></p><p>3、Gruntfile.js中的"{{destDirName}}"全部修改为当前项目的名称。</p><p>4、需要自动修改版本号请在Gruntfile.js文件中的grunt.registerTask中添加'copy:fixJs'的配置。</p></div></div><div style="padding:0 0 20px"><div class="btn btn-primary" data-toggle="collapse" data-target="#collapseExample1" aria-expanded="false" aria-controls="collapseExample1">查看最新Gruntfile.js代码</div><div class="collapse" id="collapseExample1" style="margin-top:10px"><pre><code>
// 引入 path 模块
var path = require('path');
module.exports = function (grunt) {
	// Project configuration.
	grunt.initConfig({
        serverAutoGrunt: true, //是否需要服务器自动打包
		pkg: grunt.file.readJSON('package.json'),
		// 压缩JS代码 
		uglify: {
			options: {
				mangle: {
					except: ['require']
				},
				compress: {
					drop_console: true //删除全部console信息
				}
			},
			compressJs: {
				files: [{
					expand: true,
					cwd: 'src',
					src: '**/*.js',
					dest: 'dist'
                }]
			}
		},
		// 压缩css代码 
		cssmin: {
			options: {
				process: function (content, srcpath) {
					console.log(content);
					return content.replace(/[sad ]/g, '_');
				}
			},
			target: {
				files: [{
					expand: true,
					cwd: 'src',
					src: '**/*.css',
					dest: 'dist'
                }]
			}
		},

		htmlmin: {
			dist: {
				options: {
					removeComments: true, //清除HTML注释
					collapseWhitespace: true, //压缩HTML
					collapseBooleanAttributes: true, //省略布尔属性的值 &lt;input checked="true"/> ==> &lt;input />
					removeEmptyAttributes: true, //删除所有空格作属性值 &lt;input id="" /> ==> &lt;input />
					removeScriptTypeAttributes: true, //删除&lt;script>的type="text/javascript"
					removeStyleLinkTypeAttributes: true, //删除&lt;style>和&lt;link>的type="text/css"
					minifyJS: true, //压缩页面JS
					minifyCSS: true //压缩页面CSS
				},
				files: [{
					expand: true,
					cwd: 'src',
					src: '**/*.tpl',
					dest: 'dist'
                }]
			}
		},

		// 清理字符
		copy: {
			html: {
				files: [
					{
						expand: true,
						cwd: 'src',
						src: ['**/*.{html,htm,eot,ttf,woff}'],
						dest: 'dist'
                    }
                ]
			},
			image: {
				files: [
					{
						expand: true,
						cwd: 'src',
						src: ['**/*.{png,jpg,jpeg,gif,webp,svg,ico}'],
						dest: 'dist'
                    }
                ]
			},
			// 替换css内部图片地址
			fixCss: {
				expand: true,
				cwd: 'dist',
				src: '**/*.css',
				dest: 'dist',
				options: {
					process: function (content, srcpath) {
						return content.replace(/\/src\//g, '/dist/');
					}
				}
			},
			fixJs: {
				expand: true,
				cwd: 'dist',
				src: ['**/*.js'],
				dest: 'dist',
				options: {
					process: function (content, srcpath) {//请使用当前项目名称替换以下 {{destDirName}}
						var result = content.replace(/{{destDirName}}\/src\/{{destDirName}}/g, '{{destDirName}}/dist/{{destDirName}}');
                        var getNowFormatDate = function () {
                            var date = new Date(),
                                year = date.getFullYear() + '',
                                month = date.getMonth() + 1,
                                strDate = date.getDate(),
                                hours = date.getHours(),
                                min = date.getMinutes(),
                                currentdate = '';

                            if (month >= 1 && month &lt;= 9) {
                                month = "0" + month;
                            }
                            if (strDate >= 1 && strDate &lt;= 9) {
                                strDate = "0" + strDate;
                            }
                            if (hours >= 0 && hours &lt;= 9) {
                                hours = "0" + hours;
                            }
                            if (min >= 0 && min &lt;= 9) {
                                min = "0" + min;
                            }
                            currentdate = year + month + strDate + hours + min;
                            return currentdate;
                        };
                        
						if (srcpath.indexOf('/main/main.js') > -1) {
							//修改时间戳：修改main.js里的‘#versionTime#’字符串，注：不能用$versionTime$,{{versionTime}}
							result = result.replace(/#versionTime#/g, getNowFormatDate());
						}
						return result;
					}
				}
			}
		},
		// 清空文件
		clean: {
			all: 'dist/*'
		}
	});

	// 加载包含 "uglify" 任务的插件。
	grunt.loadNpmTasks('grunt-contrib-copy');
	grunt.loadNpmTasks('grunt-contrib-uglify');
	grunt.loadNpmTasks('grunt-contrib-concat');
	grunt.loadNpmTasks('grunt-contrib-clean');
	grunt.loadNpmTasks('grunt-license');
	grunt.loadNpmTasks('grunt-contrib-cssmin');
	grunt.loadNpmTasks('grunt-contrib-htmlmin');

	grunt.registerTask('build', [
        'clean',
        'copy:html',
        'copy:image',
        // 压缩js
        'uglify',
        // 压缩css
        'cssmin',
        'htmlmin',
        'copy:fixCss',
        'copy:fixJs'//需要自动修改版本号时添加
    ]);

	// 默认被执行的任务列表。
	grunt.registerTask('default', ['build']);

};
			</code></pre></div></div></div></div>