<div class="pages-cabin-handsontablevue content-container cabin-componets-conts" id="pages-cabin-handsontablevue"><div class="container-scroll"><div class="container-scroll-content"><div class="stage-title">handsontable jq用法</div><div class="stage-title">固定行，固定列，手动固定或取消固定列</div><p>当manualColumnFreeze值为true时，选中某一列，右键菜单会出现freeze this column选项，该选项的作用是固定这一列不可水平滚动，并会将这一列移动到非固定列的前面。再次右键菜单会出现unfreeze this column，意思是取消该列的固定，并将其还原到初始位置。</p><code-temp v-bind:showdemo="true" v-bind:showhtml="true" v-bind:showjs="true" v-bind:showcss="false"><div slot="demo"><div id="handsontable_example1" style="width:100%;height:200px;overflow:auto"></div></div><div slot="html"><pre><code>&lt;div id="handsontable_example1" style="width:100%;height: 300px;overflow:auto;">&lt;/div>
        </code></pre></div><div slot="js"><pre><code>
		var example1 = $('#handsontable_example1')[0];
    var hot1 = new Handsontable(example1, {
        data: Handsontable.helper.createSpreadsheetData(200, 20),//快速生成20列，200行假数据
        rowHeaders: true,//显示行头部
        colHeaders: true,//显示列头部
        colWidths: '100px',//每列宽度
        manualColumnMove: true, //允许列拖拽
        
        fixedRowsTop: 2, //行数，固定顶部多少行不能垂直滚动
        fixedColumnsLeft: 2, //列数，固定左侧多少列不能水平滚动
        fixedRowsBottom: 2, //靠底部固定行
        
        contextMenu: true,//
        manualColumnFreeze: true, //允许手动冻结列，需要搭配contextMenu:true一起使用
      });
    </code></pre></div></code-temp><div class="stage-title">拖拽行头或列头改变行或列的大小</div><code-temp v-bind:showdemo="true" v-bind:showhtml="true" v-bind:showjs="true" v-bind:showcss="false"><div slot="demo"><div id="handsontable_example2" style="width:100%;height:200px;overflow:auto"></div></div><div slot="html"><pre><code>&lt;div id="handsontable_example2" style="width:100%;height: 300px;overflow:auto;">&lt;/div>
        </code></pre></div><div slot="js"><pre><code>
		var example2 = $('#handsontable_example2')[0];
    var hot2 = new Handsontable(example2, {
        data: Handsontable.helper.createSpreadsheetData(200, 20),//快速生成20列，200行假数据
        rowHeaders: true,//显示行头部
        colHeaders: true,//显示列头部
        colWidths: '100px',//每列宽度
        
        manualColumnMove: true, //允许列拖拽
        
        manualColumnResize:true,//当值为true时，允许拖动，当为false时禁止拖动
        manualRowResize:true//当值为true时，允许拖动，当为false时禁止拖动 
      });
    </code></pre></div></code-temp><div class="stage-title">延伸列的宽度</div><code-temp v-bind:showdemo="true" v-bind:showhtml="true" v-bind:showjs="true" v-bind:showcss="false"><div slot="demo"><div id="handsontable_example3" style="width:100%;height:200px;overflow:auto"></div></div><div slot="html"><pre><code>&lt;div id="handsontable_example3" style="width:100%;height: 300px;overflow:auto;">&lt;/div>
        </code></pre></div><div slot="js"><pre><code>
		var example3 = $('#handsontable_example3')[0];
    var hot3 = new Handsontable(example3, {
        data: Handsontable.helper.createSpreadsheetData(200, 10),//快速生成10列，200行假数据
        rowHeaders: true,//显示行头部
        colHeaders: true,//显示列头部
        
        manualColumnMove: true, //允许列拖拽
        
        stretchH: 'none'//last：延伸最后一列，all：延伸所有列，none默认不延伸。注：出现横向滚动条时效果不明显
       
      });
    </code></pre></div></code-temp><div class="stage-title">拖动行或列到某一行或列之后</div><p>当属性的值为true时，行头或列头可以被拖拽移动，移动后该行或列将会被移动到指定位置，原先该行或列的后面部分自动上移或后退。移动的时候鼠标需选中行线或列线才行。</p><code-temp v-bind:showdemo="true" v-bind:showhtml="true" v-bind:showjs="true" v-bind:showcss="false"><div slot="demo"><div id="handsontable_example4" style="width:100%;height:200px;overflow:auto"></div></div><div slot="html"><pre><code>&lt;div id="handsontable_example4" style="width:100%;height: 300px;overflow:auto;">&lt;/div>
        </code></pre></div><div slot="js"><pre><code>
		var example4 = $('#handsontable_example4')[0];
    var hot4 = new Handsontable(example4, {
        data: Handsontable.helper.createSpreadsheetData(200, 20),//快速生成20列，200行假数据
        rowHeaders: true,//显示行头部
        colHeaders: true,//显示列头部
        
        manualColumnMove:true, //当值为true时，列可拖拽移动到指定列
        manualRowMove:true:true //当值为true时，行可拖拽至指定行 
       

      });
    </code></pre></div></code-temp><div class="stage-title">设置当前选中行或列的样式</div><code-temp v-bind:showdemo="true" v-bind:showhtml="true" v-bind:showjs="true" v-bind:showcss="true"><div slot="demo"><div id="handsontable_example5" style="width:100%;height:200px;overflow:auto"></div></div><div slot="html"><pre><code>&lt;div id="handsontable_example5" style="width:100%;height: 300px;overflow:auto;">&lt;/div>
        </code></pre></div><div slot="js"><pre><code>
		var example5 = $('#handsontable_example5')[0];
    var hot5 = new Handsontable(example5, {
        data: Handsontable.helper.createSpreadsheetData(200, 20),//快速生成20列，200行假数据
        rowHeaders: true,//显示行头部
        colHeaders: true,//显示列头部
        
        currentRowClassName: 'rowStyle', //当前行样式的名称
        currentColClassName: 'Coltyle' //当前列样式的名称

      });
    </code></pre></div><div slot="css"><pre><code>
.rowStyle {
  background: #fbbdbd;
}
.Coltyle {
  background: #c6daff;
}
    </code></pre></div></code-temp><div class="stage-title">允许排序</div><p>可选值：true/false/对象</p><p>当值为true时，排序插件的使用可通过点击列头文字实现。当值为false时表示禁用排序。当值为对象时，该对象包含两个属性：column：列数。sortOrder：true/false，升序或降序，true为升序排列。当用对象启动插件后可用如下方式禁用插件： hot.updateSettings({ columnSorting:false });</p><p>排序的使用也可已直接调用sort()方法实现。如下操作： if(hot.sortingEnabled){ hot.sort(行数，true/false); //true为升序，false为降序 }</p><code-temp v-bind:showdemo="true" v-bind:showhtml="true" v-bind:showjs="true" v-bind:showcss="false"><div slot="demo"><div id="handsontable_example6" style="width:100%;height:200px;overflow:auto"></div></div><div slot="html"><pre><code>&lt;div id="handsontable_example6" style="width:100%;height: 300px;overflow:auto;">&lt;/div>
        </code></pre></div><div slot="js"><pre><code>
		var example6 = $('#handsontable_example6')[0];
    var hot6 = new Handsontable(example6, {
        data: Handsontable.helper.createSpreadsheetData(200, 20),//快速生成20列，200行假数据
        rowHeaders: true,//显示行头部
        colHeaders: true//显示列头部       
        columnSorting: true //允许排序
      });
    </code></pre></div></code-temp><div class="stage-title">显示行头列头</div><p>可选值：colHeaders:true/fals/数组，rowHeaders：true/false/数组</p><p>当值为true时显示列头，当值为数组时，列头为数组的值，当值为true时显示行头，当值为数组时，行头为数组的值</p><code-temp v-bind:showdemo="true" v-bind:showhtml="true" v-bind:showjs="true" v-bind:showcss="false"><div slot="demo"><div id="handsontable_example7" style="width:100%;height:200px;overflow:auto"></div></div><div slot="html"><pre><code>&lt;div id="handsontable_example7" style="width:100%;height: 300px;overflow:auto;">&lt;/div>
        </code></pre></div><div slot="js"><pre><code>
		var example7 = $('#handsontable_example7')[0];
    var hot7 = new Handsontable(example7, {
        data: Handsontable.helper.createSpreadsheetData(20, 5),//快速生成20列，200行假数据
        rowHeaders: ['张三', '李四', '王五'], //显示行头部
        colHeaders: ['type', 'id'], //显示列头部 
      });
    </code></pre></div></code-temp><div class="stage-title">数据显示</div><p>获取数据的方法：hot.getData()。</p><p>使用新数据更新表格的方法：hot.loadData(data)。</p><p>当不需要显示某一列的时候可用如下格式设置： columns:[ {data:0}, {data:2} ],这里只会显示第一列和第三列。</p><code-temp v-bind:showdemo="true" v-bind:showhtml="true" v-bind:showjs="true" v-bind:showcss="false"><div slot="demo"><div id="handsontable_example8" style="width:100%;height:200px;overflow:auto"></div></div><div slot="html"><pre><code>&lt;div id="handsontable_example8" style="width:100%;height: 300px;overflow:auto;">&lt;/div>
        </code></pre></div><div slot="js"><pre><code>
		var example8 = $('#handsontable_example8')[0];
    var hot8 = new Handsontable(example8, {
       data: Handsontable.helper.createSpreadsheetData(20, 5),
          rowHeaders: ['张三', '李四', '王五'], //显示行头部
          colHeaders: ['type', 'id'], //显示列头部 
          columns: [
              {
                data: 0
            },
              {
                data: 2
            }
            ] //显示指定列
      });
    </code></pre></div></code-temp><div class="stage-title">启用右键菜单</div><p>contextMenu：true/false/自定义数组 //当值为true时，启用右键菜单，为false时禁用</p><code-temp v-bind:showdemo="true" v-bind:showhtml="true" v-bind:showjs="true" v-bind:showcss="false"><div slot="demo"><div id="handsontable_example9" style="width:100%;height:200px;overflow:auto"></div></div><div slot="html"><pre><code>&lt;div id="handsontable_example9" style="width:100%;height: 300px;overflow:auto;">&lt;/div>
        </code></pre></div><div slot="js"><pre><code>
		var example9 = $('#handsontable_example9')[0];
    var hot9 = new Handsontable(example9, {
          data: Handsontable.helper.createSpreadsheetData(20, 5),
          rowHeaders:true, //显示行头部
          colHeaders:true, //显示列头部 
          contextMenu:true //使用右键菜单
      });
    </code></pre></div></code-temp><div class="stage-title">自适应列大小</div><p>autoColumnSize：true/false //当值为true且列宽未设置时，自适应列大小。</p><code-temp v-bind:showdemo="true" v-bind:showhtml="true" v-bind:showjs="true" v-bind:showcss="false"><div slot="demo"><div id="handsontable_example10" style="width:100%;height:200px;overflow:auto"></div></div><div slot="html"><pre><code>&lt;div id="handsontable_example10" style="width:100%;height: 300px;overflow:auto;">&lt;/div>
        </code></pre></div><div slot="js"><pre><code>
		var example10 = $('#handsontable_example10')[0];
    var hot10 = new Handsontable(example10, {
          data: Handsontable.helper.createSpreadsheetData(20, 10),
          rowHeaders: true, //显示行头部
          colHeaders: true, //显示列头部 
          autoColumnSize: true //自适应列大小
      });
    </code></pre></div></code-temp><div class="stage-title">设置最小，最大列、行，空列和空行数</div><p>minCols：最小列数</p><p>minRows：最小行数</p><p>maxCols：最大列数</p><p>maxRows：最大行数</p><p>minSpareCols：最小列空间（最小空列数），不足则添加空列</p><p>minSpareRows：最小行空间（最小空行数），不足则添加空行。</p><code-temp v-bind:showdemo="true" v-bind:showhtml="true" v-bind:showjs="true" v-bind:showcss="false"><div slot="demo"><div id="handsontable_example11" style="width:100%;height:200px;overflow:auto"></div></div><div slot="html"><pre><code>
          &lt;div id="handsontable_example11" style="width:100%;height: 300px;overflow:auto;">&lt;/div>
        </code></pre></div><div slot="js"><pre><code>
		var example11 = $('#handsontable_example11')[0];
    var hot11 = new Handsontable(example11, {
          data: Handsontable.helper.createSpreadsheetData(2, 2),
          rowHeaders: true, //显示行头部
          colHeaders: true, //显示列头部 
          minCols: 5, //最小列
          minRows: 5, //最小行
          maxCols: 10, //最大列
          maxRows: 10, //最大行
          minSpareCols: 2, //最小空列
          minSpareRows: 2 //最大空列
      });
    </code></pre></div></code-temp><div class="stage-title">自定义列展示</div><div style="padding-bottom:20px;z-index:1000"><i class="cabin-font-icon icon-cabin-d-UVPV handsontable-toggle-cols-btn" id="handsontable-toggle-cols-btn"></i></div><code-temp v-bind:showdemo="true" v-bind:showhtml="true" v-bind:showjs="true" v-bind:showcss="false"><div slot="demo"><div id="handsontable_example12" style="width:100%;height:200px;overflow:auto"></div></div><div slot="html"><pre><code>
          &lt;div id="handsontable_example12" style="width:120%;height: 300px;overflow:auto;">&lt;/div>
        </code></pre></div><div slot="js"><pre><code>
		var example12 = $('#handsontable_example12')[0];
    var hot12 = new Handsontable(example12, {
          data: Handsontable.helper.createSpreadsheetData(2, 2),
          rowHeaders: true, //显示行头部
          colHeaders: true, //显示列头部 
          minCols: 5, //最小列
          minRows: 5, //最小行
          maxCols: 10, //最大列
          maxRows: 10, //最大行
          minSpareCols: 2, //最小空列
          minSpareRows: 2 //最大空列
      });
    </code></pre></div></code-temp></div></div></div>